| Version: 3.3.1

Static Public Member Functions | List of all members
wxZlibInputStream Class Reference
Class List by Category » Archive support | Class List by Category » Streams

`#include <wx/zstream.h>`

Inheritance diagram for wxZlibInputStream:
[legend]

## Detailed Description

This filter stream decompresses a stream that is in zlib or gzip format.

Note that reading the gzip format requires zlib version 1.2.1 or greater, (the builtin version does support gzip format).

The stream is not seekable, wxInputStream::SeekI returns wxInvalidOffset. Also wxStreamBase::GetSize() is not supported, it always returns 0.

##

Library: wxBase
Category: Archive support, Streams

See also
  wxInputStream, wxZlibOutputStream.

## Public Member Functions
| wxZlibInputStream (wxInputStream &stream, int flags=wxZLIB_AUTO)
| If the parent stream is passed as a pointer then the new filter stream takes ownership of it. More...
| wxZlibInputStream (wxInputStream *stream, int flags=wxZLIB_AUTO)
| If the parent stream is passed as a pointer then the new filter stream takes ownership of it. More...
bool | SetDictionary (const char *data, size_t datalen)
| Sets the dictionary to the specified chunk of data. More...
bool | SetDictionary (const wxMemoryBuffer &buf)
| Sets the dictionary to the specified chunk of data. More...
Public Member Functions inherited from wxFilterInputStream
| wxFilterInputStream (wxInputStream &stream)
| Initializes a "filter" stream. More...
| wxFilterInputStream (wxInputStream *stream)
| Initializes a "filter" stream. More...
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream. More...
virtual | ~wxInputStream ()
| Destructor. More...
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block. More...
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream. More...
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary. More...
virtual size_t | LastRead () const
| Returns the last number of bytes read by the last input operation. More...
virtual char | Peek ()
| Returns the first character in the input queue without removing it. More...
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer. More...
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream. More...
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer. More...
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position. More...
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g. More...
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode. More...
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function. More...
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object. More...
virtual | ~wxStreamBase ()
| Destructor. More...
wxStreamError | GetLastError () const
| This function returns the last error. More...
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes. More...
virtual size_t | GetSize () const
| This function returns the size of the stream. More...
virtual bool | IsOk () const
| Returns true if no error occurred on the stream. More...
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets. More...
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state. More...
bool | operator! () const
| Returns the opposite of IsOk(). More...

## Static Public Member Functions
static bool | CanHandleGZip ()
| Returns true if zlib library in use can handle gzip compressed data. More...

## Additional Inherited Members
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function. More...
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function. More...
virtual wxFileOffset | OnSysTell () const
| Internal function. More...

## Constructor & Destructor Documentation

## ◆ wxZlibInputStream() [1/2]

wxZlibInputStream::wxZlibInputStream | ( | wxInputStream & | stream,
|  | int | flags = `wxZLIB_AUTO`
| ) |  |

If the parent stream is passed as a pointer then the new filter stream takes ownership of it.

If it is passed by reference then it does not.

The flags wxZLIB_ZLIB and wxZLIB_GZIP specify whether the input data is in zlib or gzip format. If wxZLIB_AUTO is used, then zlib will autodetect the stream type, this is the default.

If flags is wxZLIB_NO_HEADER, then the data is assumed to be a raw deflate stream without either zlib or gzip headers. This is a lower level mode, which is not usually used directly. It can be used to read a raw deflate stream embedded in a higher level protocol.

The values of the wxZLibFlags enumeration can be used.

## ◆ wxZlibInputStream() [2/2]

wxZlibInputStream::wxZlibInputStream | ( | wxInputStream * | stream,
|  | int | flags = `wxZLIB_AUTO`
| ) |  |

If the parent stream is passed as a pointer then the new filter stream takes ownership of it.

If it is passed by reference then it does not.

The flags wxZLIB_ZLIB and wxZLIB_GZIP specify whether the input data is in zlib or gzip format. If wxZLIB_AUTO is used, then zlib will autodetect the stream type, this is the default.

If flags is wxZLIB_NO_HEADER, then the data is assumed to be a raw deflate stream without either zlib or gzip headers. This is a lower level mode, which is not usually used directly. It can be used to read a raw deflate stream embedded in a higher level protocol.

The values of the wxZLibFlags enumeration can be used.

## Member Function Documentation

## ◆ CanHandleGZip()

static bool wxZlibInputStream::CanHandleGZip | ( |  | ) |
| static

Returns true if zlib library in use can handle gzip compressed data.

## ◆ SetDictionary() [1/2]

bool wxZlibInputStream::SetDictionary | ( | const char * | data,
|  | size_t | datalen
| ) |  |

Sets the dictionary to the specified chunk of data.

This can improve compression rate but note that the dictionary has to be the same when you deflate the data as when you inflate the data, otherwise you will inflate corrupted data.

Returns true if the dictionary was successfully set.

## ◆ SetDictionary() [2/2]

bool wxZlibInputStream::SetDictionary | ( | const wxMemoryBuffer & | buf | ) |

Sets the dictionary to the specified chunk of data.

This can improve compression rate but note that the dictionary has to be the same when you deflate the data as when you inflate the data, otherwise you will inflate corrupted data.

Returns true if the dictionary was successfully set.